import 'package:dartz/dartz.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/error/failures.dart';
import 'package:dcoupon_sdk_flutter_package/src/core/usecases/usecase.dart';
import 'package:dcoupon_sdk_flutter_package/src/domain/repositories/promotion_repository.dart';
import 'package:equatable/equatable.dart';

class PromotionGetRetailers
    implements UseCase<dynamic, PromotionGetRetailersParams> {
  final PromotionRepository? repository;

  PromotionGetRetailers(this.repository);

  @override
  Future<Either<Failure, dynamic>> call(
      PromotionGetRetailersParams params) async {
    return await repository!.getRetailers(
      publisherId: params.publisherId,
      start: params.start,
      limit: params.limit,
    );
  }
}

class PromotionGetRetailersParams extends Equatable {
  final String? publisherId;
  final int? start;
  final int? limit;

  PromotionGetRetailersParams({
    this.publisherId,
    this.start,
    this.limit,
  });

  @override
  List<Object?> get props => [
        publisherId,
        start,
        limit,
      ];
}
